/*///////////////////////////////////////////////////////////////////////////////
// Licensed Materials - Use restricted. For use in compiling interfaces to
// IBM Rational TestManager.
// (c) Copyright IBM Corporation 2006.  All Rights Reserved.
//
//	FILENAME:		proxhdr.h
//	DESCRIPTION:	implementation of Virtual User New API ty Funcs
//					Header structures
//	REVISION HISTORY
//	PROGRAMMER		DATE		REVISION
//	============================================================================
//
//	DJM				11/11/98	initial product version
//
////////////////////////////////////////////////////////////////////////////////
*/


#ifndef __INCLUDE_PROX_HDR_H
#define __INCLUDE_PROX_HDR_H	

/*
API_proxy watch file data packets come in three (3) flavors:
   a) API_ENTRY  - Packet generated before the real API is called
   b) API_EXIT   - Companion packet to above generated after API call
   c) API_SINGLE - A Single packet for the API_proxy generated after
	                the real API call containing union of above two
*/

#define API_ENTRY	1
#define API_EXIT  	2
#define API_SINGLE	3

/* All three have a common header: */

typedef struct { 
  unsigned char  major_type;	/* API_ENTRY, API_EXIT, API_SINGLE, WCH_V1 */
  unsigned char  spare_uchar;	/* Future */
  unsigned short spare_ushort;	/* Future */
  unsigned int   ticket;		/* Unique ticket for each API call */
  unsigned int   timestamp;		/* Entry TS for all but API_EXIT (api return) */
  unsigned int   total_length;	/* Total length of packet including ALL headers */
} major_wch_header;

/* API_EXIT has no secondary header */

/* API_ENTRY and API_SINGLE supply the following as a second header: */
typedef struct {
	unsigned int   process_id;		/* Process ID of API_proxy */
	unsigned int   thread_id;		/* Thread ID of API_proxy */
	unsigned int   library_id;		/* Library identifier of proxied API */
	unsigned int   API_id;			/* Unique id for each proxied API */
} minor_wch_header;

/* API_SINGLE will supply a third header following the second header: */

typedef struct {
  unsigned int   timestamp;			/* api return timestamp for API_SINGLE */
  unsigned int   alignment_uint;	/* To maintain double word alignment */
} stamp2_wch_header;

/*
Packets will be generated for an API_proxy as either a pair of API_ENRTY
and API_EXIT sharing a common ticket number OR one API_SINGLE.
*/

#endif /* __INCLUDE_PROX_HDR_H */

